//
//  AviationWeatherStationCollection.h
//
//  Created by C.K. Haun on 11/9/15.
//  Copyright © 2015 Ravenware LLC. All rights reserved.
// License
// You have the explicit right to copy, redistribute, and use any of this content provided that you;
// Acknowledge and agree that any copyright, trademark, service mark, or other is retained by C.K. Haun and Ravenware Industries LLC
// Include a reference to Ravenware.com as the origin of the content
// Acknowledge that there is no representation that any advice or techniques presented on this site are optimum or even correct
// If you use some content in your own content you include the acknowledgment "Some portions of this product created by C.K. Haun and Ravenware Industries LLC"
// You never expect or demand bug fixes or updates
// And most importantly, you agree that if you don't like something here, you don't complain, you just create a better one yourself.


#import <Foundation/Foundation.h>
#import <CoreLocation/CoreLocation.h>
#import "AviationWeatherStation.h"
@interface AviationWeatherStationCollection : NSObject <NSCopying,NSCoding>
{
    NSDate *lastUpdated;
    NSURL *fromURL;
    NSInteger numberOfStations;
    NSMutableArray *stations;
    // these two are optional, be prepared for  nil
    NSString *stateName;
    NSMutableArray *stateByStateCollection;
}
@property(nonatomic,strong) NSDate *lastUpdated;
@property (nonatomic,strong)    NSURL *fromURL;
@property (nonatomic,assign)     NSInteger numberOfStations;
@property (nonatomic,strong)NSMutableArray *stations;
@property (nonatomic,strong)     NSMutableArray *stateByStateCollection;
@property (nonatomic,strong)    NSString *stateName;

-(id)copyWithZone:(NSZone *)zone;
-(void) createStateCollections:(BOOL)usOnly;
-(NSArray *)stationsWithTAFCapability;
-(NSArray *)stationsWithMETARCapability;

-(AviationWeatherStation *)stationWithICAOID:(NSString *)thisID;
-(NSArray *)stationArrayWithPartialICAOID:(NSString *)thisID orName:(NSString *)name orState:(NSString *)state;
-(NSMutableArray *)stationsWithinDistanceFromStation:(AviationWeatherStation *)station within:(NSInteger)distance;
// singular
-(AviationWeatherStation *)stationClosestToLocation:(CLLocation *)location;
// array within a range of miles
-(NSMutableArray *)stationsClosestToLocation:(CLLocation *)location within:(NSUInteger) distance;

@end
